unit Data;

interface
uses Classes,MyTypes, MyUtils;
const MAX_SORT_KEYS = 9;
      SORT_KEY_VYSLEDKY = 7;
      utridene_znaky:string=(' 0123456789aAbBcCdDeEfFgGhHiIjJkKlLżmMnNoOpPqQrRsStTuUvVwWxXyYzZ');
      bez_D         :string=('000000000000aaa0b0ccccc0ddd0eeeee0f0g0h0iii0j0k0lllll0m0nnnnn0ooo0p0q0rrrrr0sssss0ttt0uuuuu0v0w0x0yyy0zzzzz');
var datainfo:DATABAZE_INFO;
    MZ : PZak;        // Main Zak
    MD : PDisciplina; // Main Disciplina
    MS : PSchema; // Main Schma
    MZL: TList; // Main Zak List
    MDL: TList; // Main Disciplina List
    SortKeys : array [1..MAX_SORT_KEYS] of string [20]=(
      'studuje (ano/ne) (+)',
      'typ studia (8/4) (+)',
      'ronk           (+)',
      'psmeno tdy    (+)',
      'pjmen, jmno  (+)',
      'pohlav (M/)    (+)',
      'vsledky         (+)',
      'datum narozen   (+)',
      'zatek studia   (+)');
    poradi_znaku: array[0..255] of byte;
    poradi_znaku_bez_D: array[0..255] of byte;
    cmp_functions :array[1..9]of TCmpFun;
    generator:TGenerator;
procedure Inicializuj;
procedure Dealokuj;

implementation

uses Main, Databaze, ComCtrls;

procedure Inicializuj;
begin
  MZL:=TList.Create;
  MDL:=TList.Create;
  if MS=nil then begin
    new(MS);
    MS^.discipliny:=TList.Create;
  end;
  datainfo.otevrena:=FALSE;
  datainfo.ulozena :=FALSE;
  datainfo.FileName:='';
  datainfo.TempName:='';
end;

procedure Dealokuj;
var i:integer;
    st:TSortType;
begin
  st:=MainWindow.MainListBox.SortType;
  MainWindow.MainListBox.SortType:=stNone;
  MainWindow.MainListBox.Enabled:=FALSE;
  with MainWindow.MainListBox.Items do begin
    for i:=0 to Count-1 do
      Item[i].SubItems.Clear;
    Clear;
  end;
  MainWindow.MainListBox.Enabled:=TRUE;
  MainWindow.MainListBox.SortType:=st;
  MainWindow.ComboBox1.Items.Clear;
  if MZL <> nil then begin
    while MZL.Count>0 do if MZL.Items[0]<>nil then begin
      DealokujZaka(MZL.Items[0]);
      MZL.Items[0]:=nil;
      MZL.Delete(0);
    end;
    MZL.Free;MZL:=nil;
  end;
  if MDL <> nil then begin
    while MDL.Count>0 do if MDL.Items[0]<>nil then begin
      DealokujDisciplinu(MDL.Items[0]);
      MDL.Items[0]:=nil;
      MDL.Delete(0);
    end;
    MDL.Free;MDL:=nil;
  end;
end;

begin
  datainfo.otevrena:=FALSE;
  datainfo.ulozena :=FALSE;
  datainfo.FileName:='';
  datainfo.TempName:='';
end.
