unit ZakInfoWindow;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls,MyTypes;

type
  TZakWindow = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Edit5: TEdit;
    Edit6: TEdit;
    Label8: TLabel;
    Edit7: TEdit;
    Edit8: TEdit;
    Edit9: TEdit;
    Label6: TLabel;
    Edit10: TEdit;
    Label7: TLabel;
    Edit11: TEdit;
    Label9: TLabel;
    Edit12: TEdit;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Edit13: TEdit;
    CheckBox1: TCheckBox;
    Panel1: TPanel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Panel2: TPanel;
    Label5: TLabel;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label14: TLabel;
    Edit15: TEdit;
    Label15: TLabel;
    Edit14: TEdit;
    Button4: TButton;
    procedure NastavPredlohu(p:PZak);
    procedure Inicializuj;
    procedure FormActivate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
    tol:TList;
  end;

var
  ZakWindow  : TZakWindow;
  ZakTransfer: PZak;

implementation

uses RocniSlozky, MyUtils, Databaze;
{$R *.DFM}

var ZakPtr: PZak;
    trs   : TList;

procedure TZakWindow.NastavPredlohu(p:PZak);
begin
  ZakPtr:=p;
end;

procedure TZakWindow.Inicializuj;
var dt:TDateTime;
    r,m,d:Word;
    s,s2:string[10];
begin
  dt:=Date; DecodeDate(dt,r,m,d);
  Str(r,s); dec(r,20);
  Str(r,s2);SetLength(s2,2);
  Edit1.text:='';
  Edit2.text:='';
  Edit3.text:='';
  Edit4.text:='';
  Edit5.text:='';
  Edit6.text:='';
  Edit7.text:='1';
  Edit8.text:='9';
  Edit9.text:='';
  Edit10.text:='1';
  Edit11.text:='';
  Edit12.text:='';
  Edit13.text:='A';
  Edit14.text:='';
  Edit15.text:='';
  if Length(Edit6.text) >= 2 then begin
    Edit6.SelStart:=2;
    Edit6.SelLength:=Length(Edit6.text)-2;
  end;
  if Length(Edit9.text) >=2 then begin
    Edit9.SelStart:=2;
    Edit9.SelLength:=Length(Edit9.text)-2;
  end;
  RadioButton1.checked:=TRUE;
  RadioButton2.checked:=FALSE;
  RadioButton3.checked:=TRUE;
  RadioButton4.checked:=FALSE;
  CheckBox1.checked:=TRUE;
end;

procedure TZakWindow.FormActivate(Sender: TObject);
var s:string;
begin
  trs:=nil;
  Inicializuj;
  if ZakPtr = nil then exit;
  Edit1.text:=ZakPtr^.jmeno;
  Edit2.text:=ZakPtr^.prijmeni;
  Edit3.text:=ZakPtr^.bydliste;
  Str(ZakPtr^.datum_narozeni.d,s);
  Edit4.text:=s;
  Str(ZakPtr^.datum_narozeni.m,s);
  Edit5.text:=s;
  Str(ZakPtr^.datum_narozeni.r,s);
  Edit6.text:=s;
  Str(ZakPtr^.zacatek_studia.d,s);
  Edit7.text:=s;
  Str(ZakPtr^.zacatek_studia.m,s);
  Edit8.text:=s;
  Str(ZakPtr^.zacatek_studia.r,s);
  Edit9.text:=s;
  if Length(Edit6.text) >= 2 then begin
    Edit6.SelStart:=2;
    Edit6.SelLength:=Length(Edit6.text)-2;
  end;
  if Length(Edit9.text) >=2 then begin
    Edit9.SelStart:=2;
    Edit9.SelLength:=Length(Edit9.text)-2;
  end;
  Str(ZakPtr^.startovni_trida,s);
  Edit10.text:=s;
  Str(ZakPtr^.aktualni_trida,s);
  Edit11.text:=s;
  Str(ZakPtr^.posledni_trida,s);
  Edit12.text:=s;
  if ZakPtr^.muz then
    RadioButton1.Checked:=TRUE
  else
    RadioButton2.Checked:=TRUE;
  if ZakPtr^.studuje then
    CheckBox1.Checked:=TRUE
  else
    CheckBox1.Checked:=FALSe;
  if ZakPtr^.typ_studia=8 then
    RadioButton3.Checked:=TRUE
  else
    RadioButton4.Checked:=TRUE;
  Edit13.text:=ZakPtr^.pismeno_tridy;
  Edit15.text:=ZakPtr^.ulice;
  Str(ZakPtr^.cislo_domu,s);
  Edit14.text:=s;
end;

procedure TZakWindow.Button3Click(Sender: TObject);
begin
  Inicializuj;
end;

procedure TZakWindow.FormCreate(Sender: TObject);
begin
  ZakTransfer:=nil;
  Inicializuj;
  tol:=TList.Create;
  GetTabOrderList(tol);
end;

procedure TZakWindow.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var i:integer;
    twc:TWinControl;
    b:Boolean;
begin
  twc:=Edit1;
  for i:=0 to tol.Count-1 do begin
    twc:=tol.items[i];
    if twc.Focused then
      break;
  end;
  if not twc.Focused then exit;
  case key of
    VK_UP:   b:=FALSE;
    VK_DOWN,VK_RETURN: b:=TRUE;
  else
    exit;
  end;
  twc:=FindNextControl(twc,b,TRUE,TRUE);
  twc.SetFocus;
end;

procedure TZakWindow.FormDestroy(Sender: TObject);
begin
  tol.free;
end;

procedure TZakWindow.Button1Click(Sender: TObject);
var r:integer;
    rs:PRocniSlozka;
    vzor:Boolean;
    chyba:Boolean;
    s:string;
begin
  chyba:=FALSE;
  vzor:=FALSE;
  New(ZakTransfer);
  FillChar(ZakTransfer^,sizeof(TZak),0);
  with ZakTransfer^ do begin
    jmeno:=StrAlloc(Length(Edit1.text)+1);
    StrPCopy(jmeno,Edit1.text);
    prijmeni:=StrAlloc(Length(Edit2.text)+1);
    StrPCopy(prijmeni,Edit2.text);
    bydliste:=StrAlloc(Length(Edit3.text)+1);
    StrPCopy(bydliste,Edit3.text);
    ulice:=StrAlloc(Length(Edit15.text)+1);
    StrPCopy(ulice,Edit15.text);
    Val(Edit4.text,datum_narozeni.d,r); if r<>0 then datum_narozeni.d:=0;
    Val(Edit5.text,datum_narozeni.m,r); if r<>0 then datum_narozeni.m:=0;
    Val(Edit6.text,datum_narozeni.r,r); if r<>0 then datum_narozeni.r:=0;
    Val(Edit7.text,zacatek_studia.d,r); if r<>0 then zacatek_studia.d:=0;
    Val(Edit8.text,zacatek_studia.m,r); if r<>0 then zacatek_studia.m:=0;
    Val(Edit9.text,zacatek_studia.r,r); if r<>0 then zacatek_studia.r:=0;
    Val(Edit10.text,startovni_trida,r); if r<>0 then startovni_trida :=0;
    Val(Edit11.text,aktualni_trida,r);
    Val(Edit12.text,posledni_trida,r);
    Val(Edit14.text,cislo_domu,r);      if r<>0 then cislo_domu:=0;
    studuje:=CheckBox1.Checked;

    if Length(Edit13.text)=1 then
      pismeno_tridy:= Edit13.text[1];
    if RadioButton1.Checked then
      muz:=TRUE
    else muz:=FALSE;
    if RadioButton3.Checked then
      typ_studia:=8
    else typ_studia:=4;

    if trs <> nil then begin
      rocni_slozky:=trs;
      trs:=nil;
    end else begin
      if ZakPtr <> nil then
      if ZakPtr^.rocni_slozky <> nil then
      if ZakPtr^.rocni_slozky.Count > 0 then begin
        rocni_slozky:=ZakPtr^.rocni_slozky;
        ZakPtr^.rocni_slozky:=nil;
        vzor:=TRUE;
      end;
      if not vzor then begin
        rocni_slozky:=TList.Create;
        for r:=startovni_trida to aktualni_trida do begin
          New(rs);
          rs^.trida:=r;
          rs^.pocatek.d:=1;
          rs^.pocatek.m:=9;
          rs^.pocatek.r:=zacatek_studia.r+r-startovni_trida;
          rs^.vysledky:=TList.Create;
          rocni_slozky.Add(rs);
        end;
      end;
    end;
    if studuje then begin
      if startovni_trida > aktualni_trida then begin
        MyMessageBox('Aktuln tda bude inicializovna na startovn.','Info',MB_OK);
        aktualni_trida:=startovni_trida;
        Edit11.text:=Edit10.text;
      end;
      if aktualni_trida <> posledni_trida then begin
        MyMessageBox('Posledn tda bude inicializovna na aktuln.','Info',MB_OK);
        posledni_trida:=aktualni_trida;
        Edit12.text:=Edit11.text;
      end;
    end;
    s:='Chybn daje v ';
    with datum_narozeni do if ((d=0)or(m=0)or(r=0))or((d>31)or(d<1)or(m>12)or(m<1)) then begin
      s:=s+'datu narozen ';
      chyba:=true;
    end;
    with zacatek_studia do if ((d=0)or(m=0)or(r=0))or((d>31)or(d<1)or(m>12)or(m<1)) then begin
      s:=s+', datu zahjen studia';
      chyba:=true;
    end;
    if cislo_domu=0 then begin
      s:=s+' a u sla domu';
      chyba:=true;
    end;
    if chyba then begin
      s:=s+'. Pokraovat?';
      r:=MyMessageBox(s,'Chyba v dajch',MB_YESNO);
      if r=IDNO then begin
        DealokujZaka(ZakTransfer);
        exit;
      end;
    end;
  end;
  Close;
end;

procedure TZakWindow.Button2Click(Sender: TObject);
begin
  if trs<>nil then begin
    DisposeRS(trs);
    trs:=nil;
  end;
  ZakTransfer:=nil;
  Close;
end;

procedure TZakWindow.Button4Click(Sender: TObject);
begin
  Slozky.NastavPredlohu(nil);
  if trs<>nil then begin
    Slozky.NastavPredlohu(trs);
    DisposeRS(trs);trs:=nil;
  end else if ZakPtr<>nil then
    if ZakPtr^.rocni_slozky<>nil then
      Slozky.NastavPredlohu(ZakPtr^.rocni_slozky);
  if ZakPtr<>nil then
    Slozky.Caption:='Ron sloky ('+ZakPtr^.prijmeni+' '+ZakPtr^.jmeno+')';
  Slozky.ShowModal;
  Slozky.Caption:='Ron sloky';
  trs:=SlozkyTransfer;
end;

procedure TZakWindow.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ZakPtr:=nil;
end;

end.
