unit My_IO;

interface
uses Classes,ComCtrls, MyTypes;

function  ZakVZS(p:PZak):integer; // Zak - Velikost Zapisovane Struktury
function  NactiZaka(var f:FILE):pointer;
procedure ZapisZaka(var f:FILE; p:PZak);
function  DisciplinaVZS(p:PDisciplina):integer;
function  NactiDisciplinu(var f:FILE):PDisciplina;
procedure ZapisDisciplinu(var f:FILE;p:PDisciplina);
function  ZapisData(var f:FILE;var Discipliny,Zaci:TList):Boolean;
function  NactiData(var f:FILE;var Discipliny,Zaci:TList):Boolean;
procedure NactiSchema(var f:file; var ps:PSchema);
procedure ZapisSchema(var f:FILE;var ps:PSchema);

implementation
uses SysUtils, Data, Main, MyUtils, Databaze, Forms, RocniSlozky,Windows;

function NactiZaka(var f:FILE):pointer;
var p:PZak;
    ps:PRocniSlozka;
    pv:PVysledek;
    b,v:Byte;
    i,j:word;
begin
  New(p);
  FillChar(p^,sizeof(TZak),0);
  BlockRead(f,i,2); // velikost ulozene struktury
  BlockRead(f,b,1);p^.jmeno:=StrAlloc(b+1);
  BlockRead(f,p^.jmeno^,b);p^.jmeno[b]:=#0;
  BlockRead(f,b,1);p^.prijmeni:=StrAlloc(b+1);
  BlockRead(f,p^.prijmeni^,b);p^.prijmeni[b]:=#0;
  BlockRead(f,b,1);p^.bydliste:=StrAlloc(b+1);
  BlockRead(f,p^.bydliste^,b);p^.bydliste[b]:=#0;
  BlockRead(f,b,1);p^.ulice:=StrAlloc(b+1);
  BlockRead(f,p^.ulice^,b);p^.ulice[b]:=#0;
  BlockRead(f,p^.cislo_domu,2);
  BlockRead(f,p^.datum_narozeni,sizeof(TDatum));
  BlockRead(f,p^.muz,1);
  BlockRead(f,p^.zacatek_studia,sizeof(TDatum));
  BlockRead(f,p^.typ_studia,1);
  BlockRead(f,p^.startovni_trida,1);
  BlockRead(f,p^.posledni_trida,1);
  BlockRead(f,p^.aktualni_trida,1);
  BlockRead(f,p^.studuje,1);
  BlockRead(f,p^.pismeno_tridy,1);
  BlockRead(f,b,1);
  p^.rocni_slozky:=TList.Create;
  for i:=1 to b do begin
    New(ps);
    BlockRead(f,ps^.trida,1);
    BlockRead(f,ps^.pocatek,sizeof(TDatum));
    BlockRead(f,v,1);
    ps^.vysledky:=TList.Create;
    for j:=1 to v do begin
      New(pv);
      BlockRead(f,pv^,sizeof(TVysledek));
      ps^.vysledky.add(pv);
    end;
    p^.rocni_slozky.add(ps);
  end;
  p^.Flag0:=FALSE;
  NactiZaka:=p;
end;

procedure ZapisZaka(var f:FILE; p:PZak);
var ps:PRocniSlozka;
    pv:PVysledek;
    b,v:Byte;
    i,j:integer;
begin
  i:=ZakVZS(p)+2;
  BlockWrite(f,i,2); // velikost ulozene polozky vcetne teto promenne
  b:=Strlen(p^.jmeno);
  BlockWrite(f,b,1); BlockWrite(f,p^.jmeno^,b);
  b:=Strlen(p^.prijmeni);
  BlockWrite(f,b,1); BlockWrite(f,p^.prijmeni^,b);
  b:=Strlen(p^.bydliste);
  BlockWrite(f,b,1); BlockWrite(f,p^.bydliste^,b);
  b:=Strlen(p^.ulice);
  BlockWrite(f,b,1); BlockWrite(f,p^.ulice^,b);
  BlockWrite(f,p^.cislo_domu,2);
  BlockWrite(f,p^.datum_narozeni,sizeof(TDatum));
  BlockWrite(f,p^.muz,1);
  BlockWrite(f,p^.zacatek_studia,sizeof(TDatum));
  BlockWrite(f,p^.typ_studia,1);
  BlockWrite(f,p^.startovni_trida,1);
  BlockWrite(f,p^.posledni_trida,1);
  BlockWrite(f,p^.aktualni_trida,1);
  BlockWrite(f,p^.studuje,1);
  BlockWrite(f,p^.pismeno_tridy,1);
  b:=p^.rocni_slozky.Count;
  BlockWrite(f,b,1);
  for i:=0 to b-1 do begin
    ps:=p^.rocni_slozky.Items[i];
    BlockWrite(f,ps^.trida,1);
    BlockWrite(f,ps^.pocatek,sizeof(TDatum));
    v:=ps^.vysledky.Count;
    BlockWrite(f,v,1);
    for j:=0 to v-1 do begin
      pv:=ps^.vysledky.Items[j];
      BlockWrite(f,pv^,sizeof(TVysledek));
    end;
  end;
end;

function ZakVZS(p:PZak):integer;
var i,size:integer;
    ps:PRocniSlozka;
begin
  size:=0;
  if p <> nil then begin
    inc(size,StrLen(p^.jmeno)+1);
    inc(size,StrLen(p^.prijmeni)+1);
    inc(size,StrLen(p^.bydliste)+1);
    inc(size,StrLen(p^.ulice)+1);
    inc(size,2*sizeof(TDatum)+10);
    if p^.rocni_slozky <> nil then begin
      inc(size,(sizeof(TDatum)+2)*p^.rocni_slozky.Count);
      for i:=0 to p^.rocni_slozky.Count-1 do begin
        ps := p^.rocni_slozky.Items[i];
        if ps <> nil then
          inc(size,sizeof(TVysledek)*ps^.vysledky.Count);
      end;
    end;
  end;
  ZakVZS:=size;
end;

function NactiDisciplinu(var f:FILE):PDisciplina;
var i:integer;
    w:word;
    b:byte;
    p:PDisciplina;
begin
  BlockRead(f,w,2);
  BlockRead(f,b,1);i:=b;
  New(p); p^.jmeno:=StrAlloc(i+1);
  BlockRead(f,p^.jmeno[0],i);p^.jmeno[i]:=#0;
  BlockRead(f,p^.id,1);
  BlockRead(f,p^.format_jednotky,1);
  NactiDisciplinu:=p;
end;

procedure ZapisDisciplinu(var f:FILE;p:PDisciplina);
var i:integer;
begin
  i:=StrLen(p^.jmeno)+3;
  BlockWrite(f,i,2);//velikost struktury
  dec(i,3);
  BlockWrite(f,i,1);//delka jmena
  BlockWrite(f,p^.jmeno[0],i);
  BlockWrite(f,p^.id,1);
  BlockWrite(f,p^.format_jednotky,1);
end;

function DisciplinaVZS(p:PDisciplina):integer;
var size:integer;
begin
  size:=0;
  if p <> nil then
    inc(size,StrLen(p^.jmeno)+3);
  DisciplinaVZS:=size;
end;

function NactiData(var f:FILE;var Discipliny,Zaci:TList):Boolean;
var i,j,nd,nz,r,rmax:integer;
    dr,dm,dd,w:Word;
    dt:TDateTime;
    pd : PDisciplina;
    pz : PZak;
    prs: TList;
    rs:PRocniSlozka;
    s,s2,s3:string[20];
    st:TSortType;
begin
  if Zaci=nil then Zaci:=TList.Create;
  if Discipliny=nil then Discipliny:=TList.Create;
  BlockRead(f, w, 2);
  BlockRead(f, w, 2);nd:=w;
  if nd>256 then raise EInOutError.Create('Velky pocet disciplin');
  for i:=1 to nd do begin
    pd:=NactiDisciplinu(f);
    Discipliny.Add(pd);
  end;
  BlockRead(f, w, 2);
  BlockRead(f, w, 2);nz:=w;
  for i:=1 to nz do begin
    pz:=NactiZaka(f);
    Zaci.Add(pz);
  end;
  NactiData:=TRUE;

  dt:=Date;DecodeDate(dt,dr,dm,dd);
  if dm < 9 then dec(dr);
  rmax:=0;
  for i:=0 to Zaci.Count-1 do begin
    pz:=Zaci.Items[i];
    if pz=nil then continue;
    if not pz^.studuje then continue;
    r:=pz^.zacatek_studia.r+pz^.aktualni_trida-1;
    if r>rmax then rmax:=r;
    if pz.rocni_slozky<>nil then begin
      prs:=pz.rocni_slozky;
      for j:=0 to prs.Count-1 do begin
        rs:=prs.Items[j];
        r:=rs^.pocatek.r;
        if r>rmax then rmax:=r;
      end;
    end;
  end;
  if dr>rmax then begin
    Str(rmax,s);Str(rmax+1,s3);s:=s+'\'+s3;
    Str(dr,s2);Str(dr+1,s3);s2:=s2+'\'+s3;
    r:=MyMessageBox('koln rok '+s+' ji nen aktuln. Pejt na k. rok '+s2+'?','Aktualizace databze',MB_YESNO);
    if r=IDYES then begin
      for i:=0 to Zaci.Count-1 do begin
        pz:=Zaci.Items[i];
        if pz=nil then continue;
        if not pz^.studuje then continue;
        if pz^.aktualni_trida>=pz^.typ_studia then begin
          pz^.aktualni_trida:=pz^.typ_studia;
          pz^.posledni_trida:=pz^.typ_studia;
          pz^.studuje:=FALSE;
          continue;
        end;
        inc(pz^.aktualni_trida);
        if pz^.posledni_trida<pz^.aktualni_trida then pz^.posledni_trida:=pz^.aktualni_trida;
        if pz.rocni_slozky<>nil then begin
          prs:=pz.rocni_slozky;
          New(rs);
          rs^.trida:=pz^.aktualni_trida;
          rs^.pocatek.d:=1;
          rs^.pocatek.m:=9;
          rs^.pocatek.r:=dr;
          prs.Add(rs);
          rs^.Vysledky:=TList.Create;
          //rs^.vysledky...  - melo by nacist schema prislusne nove tridy
        end;
      end;
    end;
  end;
  st:=MainWindow.MainListBox.Sorttype;
  MainWindow.MainListBox.Sorttype:=stNone;
  MainWindow.MainListBox.Enabled:=FALSE;
  for i:=0 to Zaci.Count-1 do begin
    pz:=Zaci.Items[i];
    AddToListView(pz,MainWindow.MainListBox);
  end;
  MainWindow.MainListBox.Enabled:=TRUE;
  MainWindow.MainListBox.Sorttype:=st;
end;

function ZapisData(var f:FILE;var Discipliny,Zaci:TList):Boolean;
var i,nd,nz,sd,sz:integer;
begin
  if (Discipliny=nil)or(Zaci=nil) then begin
    ZapisData:=FALSE;
    exit;
  end;
  nd:=Discipliny.Count;
  nz:=Zaci.Count;
  BlockWrite(f, nd, 2);
  BlockWrite(f, nd, 2);
  for i:=0 to nd-1 do
    ZapisDisciplinu(f, Discipliny.Items[i]);
  sd:=FilePos(f);
  seek(f, 0);
  BlockWrite(f, sd, 2);
  seek(f, sd);
  BlockWrite(f, nd, 2);
  BlockWrite(f, nz, 2);
  for i:=0 to nz-1 do
    ZapisZaka(f, Zaci.Items[i]);
  sz:=FilePos(f)-sd;
  seek(f, sd);
  BlockWrite(f, sz, 2);
  seek(f, sd+sz);
  ZapisData:=TRUE;
end;

procedure  NactiSchema(var f:file; var ps:PSchema);
var i,j:integer;
    count:Word;
    pb:^byte;
begin
  new(ps); ps^.discipliny:=TList.Create;
  count:=0;
  BlockRead(f, count, 2,i);
  if count>256 then begin
    raise EInOutError.Create('Chyba v datech - pli mnoho discipln');
  end;
  for j:=1 to count do begin
    new(pb);
    BlockRead(f,pb^,1,i);
    ps^.discipliny.Add(pb);
  end;
end;

procedure ZapisSchema(var f:FILE;var ps:PSchema);
var pb:^byte;
    i,j:integer;
begin
  if ps=nil then exit;
  if ps^.discipliny=nil then exit;
  j:=ps^.discipliny.Count;
  BlockWrite(f, j, 2, i);
  for j:=0 to ps^.discipliny.Count-1 do begin
    pb:=ps^.discipliny.Items[j];
    BlockWrite(f,pb^,1,i);
  end;
end;

end.
