unit SchemaWindow;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    RadioGroup3: TRadioGroup;
    Button2: TButton;
    Button3: TButton;
    RadioGroup4: TRadioGroup;
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses MyTypes, MyUtils, My_IO, Data, Main;
{$R *.DFM}

procedure TForm1.Button3Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Button2Click(Sender: TObject);
var pz:PZak;
    rs:PRocniSlozka;
    i,j:integer;
    f:file;
    ps:PSchema;
    trida,trida2:integer;
    typ_studia:byte;
    pv:PVysledek;
begin
  trida:=RadioGroup4.ItemIndex+1;
  typ_studia:=0;
  case RadioGroup2.ItemIndex of
    1: typ_studia:=8;
    2: typ_studia:=4;
  end;
  if RadioGroup1.ItemIndex=0 then begin
    ps:=MS;
  end else begin
    if MainWindow.OpenDialog3.Execute then begin
      try
        AssignFile(f, MainWindow.OpenDialog3.FileName);
        Reset(f,1);
      except
        on EInOutError do begin
          MyMessageBox('Chyba pri otevrn souboru.','Info',MB_OK);
          exit;
        end;
      end;
      try
        NactiSchema(f,ps);
      except
        on EInOutError do begin
          MyMessageBox('Chyba pi natni dat schmatu.','Info',MB_OK);
          exit;
        end;
      end;
      CloseFile(f);
    end else exit;
  end;

  with MainWindow do begin
    if MainListBox.SelCount>0 then begin
      for i:=0 to MainListBox.Items.Count-1 do begin
        if not MainListBox.Items.Item[i].Selected then continue;
        pz:=MainListBox.Items.Item[i].Data;
        if pz=nil then continue;
        if (typ_studia<>0)and(typ_studia<>pz^.typ_studia) then continue;
        if pz^.rocni_slozky=nil then pz^.rocni_slozky:=TList.Create;
        rs:=nil;
        for j:=0 to pz^.rocni_slozky.Count-1 do begin
          rs:=pz^.rocni_slozky.Items[j];
          if rs=nil then continue;
          if pz^.typ_studia=4 then
            trida2:=rs^.trida+4
          else
            trida2:=rs^.trida;
          if trida=trida2 then break
          else rs:=nil;
        end;
        if rs=nil then continue;
        if SchemaWindow.Form1.RadioGroup3.ItemIndex=1 then begin
          for j:=0 to rs^.vysledky.Count-1 do begin
            pv:=rs^.vysledky.Items[j];
            Dispose(pv);
            rs^.vysledky.Items[j]:=nil;
          end;
          rs^.vysledky.Clear;
        end;
        PouzijSchema(ps, rs);
      end;
    end;
  end;
  if ps<>MS then
    DealokujSchema(ps);
  Close;
end;


end.
